<?php

declare(strict_types=1);

namespace Drupal\vipps_mobilepay\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBase;
use Drupal\vipps_mobilepay\VippsMobilepayConnectionInterface;

/**
 * Defines the Vipps MobilePay connection profile entity type.
 *
 * @ConfigEntityType(
 *   id = "vipps_mobilepay_connection",
 *   label = @Translation("Vipps MobilePay Connection Profile"),
 *   label_collection = @Translation("Vipps MobilePay Connection Profiles"),
 *   label_singular = @Translation("Vipps MobilePay connection profile"),
 *   label_plural = @Translation("Vipps MobilePay connection profiles"),
 *   label_count = @PluralTranslation(
 *     singular = "@count Vipps MobilePay connection profile",
 *     plural = "@count Vipps MobilePay connection profiles",
 *   ),
 *   handlers = {
 *     "list_builder" =
 *   "Drupal\vipps_mobilepay\VippsMobilepayConnectionListBuilder",
 *     "form" = {
 *       "add" = "Drupal\vipps_mobilepay\Form\VippsMobilepayConnectionForm",
 *       "edit" = "Drupal\vipps_mobilepay\Form\VippsMobilepayConnectionForm",
 *       "delete" = "Drupal\Core\Entity\EntityDeleteForm",
 *     },
 *   },
 *   config_prefix = "vipps_mobilepay_connection",
 *   admin_permission = "administer vipps_mobilepay_connection",
 *   links = {
 *     "collection" = "/admin/structure/vipps-mobilepay-connection",
 *     "add-form" = "/admin/structure/vipps-mobilepay-connection/add",
 *     "edit-form" =
 *   "/admin/structure/vipps-mobilepay-connection/{vipps_mobilepay_connection}",
 *     "delete-form" =
 *   "/admin/structure/vipps-mobilepay-connection/{vipps_mobilepay_connection}/delete",
 *   },
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *     "uuid" = "uuid",
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "market",
 *     "mode",
 *     "client_id",
 *     "client_secret",
 *     "subscription_key",
 *     "merchant_serial_number",
 *   },
 * )
 */
final class VippsMobilepayConnection extends ConfigEntityBase implements VippsMobilepayConnectionInterface {

  /**
   * The example ID.
   */
  protected string $id;

  /**
   * The example label.
   */
  protected string $label;

  /**
   * The market.
   */
  protected string $market;

  /**
   * The connection mode.
   */
  protected string $mode;

  /**
   * The Client ID.
   */
  protected string $client_id;

  /**
   * The Client Secret.
   */
  protected string $client_secret;

  /**
   * The Subscription Key.
   */
  protected string $subscription_key;

  /**
   * The Merchant Serial Number.
   */
  protected string $merchant_serial_number;

}
