<?php

namespace Drupal\vipps_mobilepay;

use zaporylie\Vipps\ClientInterface;

/**
 * Provides the VippsMobilePay manager factory interface.
 */
interface VippsMobilePayManagerFactoryInterface {

  /**
   * Instantiate a new VippsMobilePay manager for the given config.
   *
   * @param \Drupal\vipps_mobilepay\VippsMobilepayConnectionInterface $connection
   *   The connection entity.
   *
   * @return \zaporylie\Vipps\ClientInterface
   *   The manager.
   */
  public function get(VippsMobilepayConnectionInterface $connection): ClientInterface;

}
